"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _vue = require("vue");

var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));

var _empty = _interopRequireDefault(require("../empty"));

var _ = require("./");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RenderEmpty = {
  props: {
    componentName: _vueTypes.default.string
  },
  setup: function setup(props) {
    var configProvider = (0, _vue.inject)('configProvider', _.ConfigConsumerProps);

    function renderHtml(componentName) {
      var getPrefixCls = configProvider.getPrefixCls;
      var prefix = getPrefixCls('empty');

      switch (componentName) {
        case 'Table':
        case 'List':
          return (0, _vue.createVNode)(_empty.default, {
            "image": (0, _vue.createVNode)(_empty.default.PRESENTED_IMAGE_SIMPLE, null, null)
          }, null);

        case 'Select':
        case 'TreeSelect':
        case 'Cascader':
        case 'Transfer':
        case 'Mentions':
          return (0, _vue.createVNode)(_empty.default, {
            "image": (0, _vue.createVNode)(_empty.default.PRESENTED_IMAGE_SIMPLE, null, null),
            "class": "".concat(prefix, "-small")
          }, null);

        default:
          return (0, _vue.createVNode)(_empty.default, null, null);
      }
    }

    return function () {
      return renderHtml(props.componentName);
    };
  }
};

function renderEmpty(componentName) {
  return (0, _vue.createVNode)(RenderEmpty, {
    "componentName": componentName
  }, null);
}

var _default = renderEmpty;
exports.default = _default;